from clarabot_nano_common.common.error import log_escape_str

from clarabot_nano.common.request.server_general import AdminDetachDriveRequest
from clarabot_nano.server.general.handler.admin.config_update.base import AbstractAdminConfigUpdateServerHandler


class DetachDriveHandler(AbstractAdminConfigUpdateServerHandler):
    HANDLER_KEY = AdminDetachDriveRequest.TYPE_KEY

    def _create_config_update_request(self) -> dict:
        return {
            "_handler_key": "drive:detach-room",
            "path": self.payload.get(AdminDetachDriveRequest.PATH),
            "room_id": self.payload.get(AdminDetachDriveRequest.TARGET_ROOM_ID),
        }

    def _log_message(self) -> str:
        return (
            f"Detach drive at {log_escape_str(self.payload.get(AdminDetachDriveRequest.PATH))} "
            f"from room {self.payload.get(AdminDetachDriveRequest.TARGET_ROOM_ID)}"
        )
